//Copyright (c) 1998 The Open Group
//
//Permission to use, copy, modify, and distribute this software and its documentation for
//any purpose and without fee is hereby granted, provided that the above copyright notice
//appears in all copies and that both the copyright notice and this permission notice
//appear in supporting documentation, and that the name of ("TOG") or The Open Group not
//be used in advertising or publicity pertaining to distribution of the software without
//specific, written prior permission.
//
//THE OPEN GROUP DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE INCLUDING ALL
//IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. IN NO EVENT
//SHALL TOG BE LIABLE FOR ANY SPECIAL, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
//WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN ACTION OF CONTRACT,
//NEGLIGENCE, OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
//PERFORMANCE OF THIS SOFTWARE. 

package ORG.opengroup.axtp.xface;
import ORG.opengroup.axtp.transaction.*;
import ORG.opengroup.xface.*;
import ORG.opengroup.jar.*;
import java.io.*;

/**
 * An interface for creating transactions.
 */
public class XTransactionFactory
	extends XSerialization
	implements TransactionFactory
{
	public XFace createXFace(XObj xObj, ClassLoader cl)
		throws IOException, ClassNotFoundException
	{
		String type=xObj.getType();
		if ("A".equals(type))
			return new XA();
		if ("C".equals(type))
			return new XC();
		if ("N".equals(type))
			return new XN();
		if ("Q".equals(type))
			return new XQ();
		if ("R".equals(type))
			return new XR();
		if ("W".equals(type))
			return new XW();
		if ("X".equals(type))
			return new XX();
		if ("Z".equals(type))
			return new XZ();
		return super.createXFace(xObj,cl);
	}

	public A createA()
	{
		try
		{
			XA xa=new XA();
			XObj xObj=createXObj();
			xObj.setType("A");
			xa.setXObj(xObj);
			xObj.setXFace(xa);
			return xa;
		} catch (Exception e)
		{
			return null;
		}
	}

	public C createC()
	{
		try
		{
			XC xc=new XC();
			XObj xObj=createXObj();
			xObj.setType("C");
			xc.setXObj(xObj);
			xObj.setXFace(xc);
			return xc;
		} catch (Exception e)
		{
			return null;
		}
	}

	public N createN()
	{
		try
		{
			XN xn=new XN();
			XObj xObj=createXObj();
			xObj.setType("N");
			xn.setXObj(xObj);
			xObj.setXFace(xn);
			return xn;
		} catch (Exception e)
		{
			return null;
		}
	}

	public Q createQ()
	{
		try
		{
			XQ xq=new XQ();
			XObj xObj=createXObj();
			xObj.setType("Q");
			xq.setXObj(xObj);
			xObj.setXFace(xq);
			return xq;
		} catch (Exception e)
		{
			return null;
		}
	}

	public R createR()
	{
		try
		{
			XR xr=new XR();
			XObj xObj=createXObj();
			xObj.setType("R");
			xr.setXObj(xObj);
			xObj.setXFace(xr);
			return xr;
		} catch (Exception e)
		{
			return null;
		}
	}

	public W createW()
	{
		try
		{
			XW xw=new XW();
			XObj xObj=createXObj();
			xObj.setType("W");
			xw.setXObj(xObj);
			xObj.setXFace(xw);
			return xw;
		} catch (Exception e)
		{
			return null;
		}
	}

	public X createX()
	{
		try
		{
			XX xx=new XX();
			XObj xObj=createXObj();
			xObj.setType("X");
			xx.setXObj(xObj);
			xObj.setXFace(xx);
			return xx;
		} catch (Exception e)
		{
			return null;
		}
	}

	public Z createZ()
	{
		try
		{
			XZ xz=new XZ();
			XObj xObj=createXObj();
			xObj.setType("Z");
			xz.setXObj(xObj);
			xObj.setXFace(xz);
			return xz;
		} catch (Exception e)
		{
			return null;
		}
	}
}
