//Copyright (c) 1997 The Open Group
//
//Permission to use, copy, modify, and distribute this software and its documentation for
//any purpose and without fee is hereby granted, provided that the above copyright notice
//appears in all copies and that both the copyright notice and this permission notice
//appear in supporting documentation, and that the name of ("TOG") or The Open Group not
//be used in advertising or publicity pertaining to distribution of the software without
//specific, written prior permission.
//
//THE OPEN GROUP DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE INCLUDING ALL
//IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. IN NO EVENT
//SHALL TOG BE LIABLE FOR ANY SPECIAL, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
//WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN ACTION OF CONTRACT,
//NEGLIGENCE, OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
//PERFORMANCE OF THIS SOFTWARE. 

package ORG.opengroup.misc;
import java.io.*;

/**
 * Extends ObjectInputStream by allowing explicit specification of the class loader.
 */
public class ObjInStr extends ObjectInputStream
{
	private ClassLoader cl;

	/**
	 * Constructor. Instantiates an instance of this of class.
	 * @param is the input stream
	 * @param pcl the class loader
	 */
	public ObjInStr(InputStream is, ClassLoader pcl)
		throws IOException
	{
		super(is);
		cl=pcl;
	}

	protected Class resolveClass(ObjectStreamClass v)
		throws IOException, ClassNotFoundException
	{
		if (cl==null)
			return super.resolveClass(v);
		String nam=v.getName();
		return cl.loadClass(nam);
	}
}
