//based on the beanbox
package ORG.opengroup.moajar;
import ORG.opengroup.awt.*;
import ORG.opengroup.beans.*;
import java.awt.*;
import java.awt.event.*;
import java.beans.*;
import java.lang.reflect.*;

/**
 * Allows for the selection and editing of a property.
 */
public class PropertySheetDialog extends ButtonDialog
{
	private Object target;
	private PropertyEditorAccess pea;
	private List list;
	private PropertyDescriptor properties[];
	private PropertyEditor editors[];
      private boolean indexed[];
      private int cndx[];
      private Method getters[];
      private Method setters[];
	private String names[];
	private Component views[];
	private Component selectedView;
	String selectedItem;
      Panel pv;
	TextField tfx;
      int pndx=-1;

	class XTF extends TextField
      {
            public XTF(int w)
		{
			super(w);
		}

		public boolean keyUp(Event e, int key) 
		{
			if (e.target==this && pndx>-1 && indexed[pndx]) 
			{
				try 
				{
					Integer indx = new Integer(getText());
                              cndx[pndx]=indx.intValue();
					Object gargs[] = { indx };
					Object o = getters[pndx].invoke(target, gargs);
					editors[pndx].setValue(o);
					selectedView.setVisible(true);
				} catch (Exception ex) 
				{
					selectedView.setVisible(false);
				}
				views[pndx].repaint();
			}
			return (false);
		}
      }

	class ListIL implements ItemListener
	{
		public void itemStateChanged(ItemEvent ie)
		{
			String nsf=list.getSelectedItem();
			if (nsf==null && selectedItem==null)
				return;
			if (nsf!=null && nsf.equals(selectedItem))
				return;
			if (selectedView!=null)
			{
				pv.remove(selectedView);
				selectedView=null;
			}
			if (nsf==null)
			{
				selectedItem=null;
				pack();
				return;
			}
			int i;
			for(i=0;i<properties.length;++i)
			{
				if (nsf.equals(names[i]))
				{
					selectedItem=nsf;
					Object o;
					try 
					{
						views[i].setVisible(true);
						Method getter = getters[i];
						if (indexed[i])
						{
							Integer indx = new Integer(cndx[i]);
							tfx.setText(indx.toString());
							pndx=i;
							tfx.setVisible(true);
							Object gargs[] = { indx };
							o = getter.invoke(target, gargs);
						}
						else
						{
							tfx.setVisible(false);
							pndx=-1;
							Object args[] = { };
							o = getter.invoke(target, args);
						}
						editors[i].setValue(o);
						selectedView=views[i];
						pv.add("Center",selectedView);
					} catch (Exception ex) 
					{
						selectedView=null;
					}
					pack();
					return;
				}
			}
			pack();
		}
	}

	class EditedAdaptor implements PropertyChangeListener 
	{
		int i;

            public EditedAdaptor(int ndx)
		{
			i=ndx;
		}

		public void propertyChange(PropertyChangeEvent evt) 
		{
			synchronized (PropertySheetDialog.this)
			{
				if (evt.getSource() instanceof PropertyEditor) 
				{
					PropertyEditor editor = (PropertyEditor) evt.getSource();
					PropertyDescriptor property = properties[i];
					Object value = editor.getValue();
					Method setter = setters[i];
					try 
					{
						if (indexed[i])
						{
							Integer indx = new Integer(cndx[i]);
							Object args[] = { indx, value };
							setter.invoke(target, args);
						}
						else
						{
							Object args[] = { value };
							setter.invoke(target, args);
						}
					} catch (java.lang.reflect.InvocationTargetException ex) 
					{
						if (ex.getTargetException() instanceof PropertyVetoException) 
							warning("Vetoed; reason is: " + ex.getTargetException().getMessage());
						else
							error("InvocationTargetException while updating " + 
								property.getName(), ex);
					} catch (Exception ex) 
					{
						error("Unexpected exception while updating " + 
							property.getName(), ex);
					}
					if (views[i] == selectedView && views[i] instanceof PropertyCanvas)
						views[i].repaint();
				}
			}
		}
	}

	/**
	 * Construct the dialog. To allow subclassing, show() is not called.
	 * @param parent		The parent frame.
	 * @param title		Window title.
	 * @param x			x-location of the dialog.
	 * @param y			y-location of the dialog.
	 * @param buttonLabels	Button labels, one button per line.
	 * @param ptarget		Object to be configured.
	 */
	public PropertySheetDialog(
		Frame parent, 
		String title, 
		int x, 
		int y,
		String buttonLabels, 
		Object ptarget)
	{
		super(parent,title,x,y,buttonLabels);
		target=ptarget;
		selectedItem=null;
		selectedView=null;

		try 
		{
			pea = new PropertyEditorAccess(target);
			properties = pea.getPropertyDescriptors();
		} catch (Exception ex) 
		{
			error("PropertySheet: Couldn't introspect", ex);
			return;
		}

		editors = new PropertyEditor[properties.length];
		indexed = new boolean[properties.length];
		cndx = new int[properties.length];
		getters = new Method[properties.length];
		setters = new Method[properties.length];
		views = new Component[properties.length];
		names = new String[properties.length];
		int lsz=10;
		if (properties.length<lsz)
			lsz=properties.length;
		list=new List(lsz);
		list.addItemListener(new PropertySheetDialog.ListIL());
		int i;
		for (i=0;i<properties.length;++i)
		{
			editors[i]=null;
                  indexed[i]=false;
                  cndx[i]=0;
			views[i]=null;
			names[i]=null;

			// Don't display hidden or expert properties.
			if (properties[i].isHidden() || properties[i].isExpert()) 
				continue;

			// Only display editable properties.
			if (!pea.selectProperty(i))
				continue;

			PropertyEditor editor = pea.getPropertyEditor();
			Method getter = properties[i].getReadMethod();
			Method setter = properties[i].getWriteMethod();

                  if (editor==null)
                  {
                        indexed[i]=true;
				editor = pea.getIndexedPropertyEditor();
				IndexedPropertyDescriptor ipd=(IndexedPropertyDescriptor)properties[i];
				getter = ipd.getIndexedReadMethod();
				setter = ipd.getIndexedWriteMethod();
                  }

			editors[i] = editor;
                  getters[i]=getter;
                  setters[i]=setter;

			String name = properties[i].getDisplayName();
			Component view = null;

			// If we can't edit this component, skip it.
			if (editor == null)
				continue;

			try 
			{
				Object value;
				if (indexed[i])
				{
					Integer indx = new Integer(0);
					Object gargs[] = { indx };
					value = getter.invoke(target, gargs);
				}
				else
				{
					Object args[] = { };
					value = getter.invoke(target, args);
				}
				editor.setValue(value);
				editor.addPropertyChangeListener(new PropertySheetDialog.EditedAdaptor(i));

				// Now figure out how to display it...
				if (editor.isPaintable() && editor.supportsCustomEditor()) 
					view = new PropertyCanvas((Frame)this.getParent(), editor);
				else if (editor.getTags() != null) 
					view = new PropertySelector(editor);
				else if (editor.getAsText() != null)
				{
					String init = editor.getAsText();
					view = new PropertyText(editor);
				} 
				else 
				{
					System.err.println("Skipping non-displayable property " + name);
					continue;
				}
			} catch (Exception ex) 
			{
				continue;
			}
			names[i]=name;
			views[i]=view;
			list.add(name);
		}

		pv=new Panel();
		pv.setLayout(new BorderLayout(5,5));
            add("Center",pv);
            tfx=new XTF(4);
		tfx.setVisible(false);
            pv.add("West",tfx);
		add("North",list);
		pack();
	}

	void warning(String s) 
	{
		TextAreaDialog bd=new TextAreaDialog(
			(Frame)this.getParent(),
			"Warning",
			300,300,
			s,
			"Continue");
		bd.show();
	}

	void error(String message, Exception ex) 
	{
		String mess = message + ":\n" + ex;
		System.err.println(message);
		ex.printStackTrace();
		// Popup an Error Dialog with the given error message.
		TextAreaDialog bd=new TextAreaDialog(
			(Frame)this.getParent(),
			"Error",
			300,300,
			mess,
			"Continue");
		bd.show();
	}
}
