//Copyright (c) 1998 The Open Group
//
//Permission to use, copy, modify, and distribute this software and its documentation for
//any purpose and without fee is hereby granted, provided that the above copyright notice
//appears in all copies and that both the copyright notice and this permission notice
//appear in supporting documentation, and that the name of ("TOG") or The Open Group not
//be used in advertising or publicity pertaining to distribution of the software without
//specific, written prior permission.
//
//THE OPEN GROUP DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE INCLUDING ALL
//IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. IN NO EVENT
//SHALL TOG BE LIABLE FOR ANY SPECIAL, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
//WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN ACTION OF CONTRACT,
//NEGLIGENCE, OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
//PERFORMANCE OF THIS SOFTWARE. 

package ORG.opengroup.xface;

/**
 * A minimal implimentation of XFace.
 * Useful for deserializing XML which contains unknown types.
 */
public class XFaceDefault implements XFace
{
	private XObj xObj=null;

	/**
	 * Simply returns the associated XML object.
	 */
	public XObj getXObj()
	{
		return xObj;
	}

	/**
	 * Assigns an XML object to the face object.
	 * At the time of the assignment, the face object 
	 * extracts all appropriate data from the XML object.
	 */
	public void setXObj(XObj xObj)
	{
		this.xObj=xObj;
	}

	/**
	 * Refreshes the XML object with current data held by the face object.
	 * (Called by XObj.toString().)
	 */
	public void refreshXObj()
	{
	}
}